// 数据结构

package admin

import (
	"time"

	"github.com/qor5/x/login"
	"gorm.io/gorm"
)

// -------------------------------------------------------------------------------- 用户

// name 中文名称
// index/edit/new 列表/编辑/新建 时是否显示 index:"-" 不显示
// special:"-"  ?

// 用户
type User struct {
	gorm.Model
	Categorize   UserCategorize `name:"分类"` // 分类
	CategorizeId uint           //
	NickName     string         `name:"昵称"` // 昵称
	TrueName     string         // 真名
	Sex          uint           // 性别
	LoginName    string         // 登陆名
	LoginPass    string         // 登陆密码
	LastIP       string         // 最后登陆IP
	LastTime     time.Time      // 最后登陆日期
	LoginNum     uint           // 登陆次数
	Active       bool           // 是否可用
	Tag          string         // 用户标签
	Like         string         // 爱好
	Addr         string         // 住址
	Tel          string         // 电话
	Age          uint           // 年龄
	IntroducerId uint           // 介绍人ID

	login.UserPass
	login.OAuthInfo
	login.SessionSecure
}

// 用户收藏夹
type UserFavorites struct {
	gorm.Model
}

// 用户关注
type UserFollow struct {
	gorm.Model
}

// 用户分类
type UserCategorize struct {
	gorm.Model
	UserId uint // 用户(管理员)给用户作的分类
}

// -------------------------------------------------------------------------------- 文章

// 文章分类
type DocumentCategorize struct {
	gorm.Model
	Title  string `name:"标题"` // 分类标题
	Active bool   `name:"可用"` // 可用
	Order  uint   `name:"顺序"` // 显示顺序
	Note   string `name:"备注"` // 备注
}

// 文章
type Document struct {
	gorm.Model
	Categorize       DocumentCategorize // 分类
	CategorizeId     uint               //
	Title            string             `name:"标题"`  // 文章标题
	Show             bool               `name:"显示"`  // 是否显示
	Author           string             `name:"作者"`  // 作者
	Source           string             `name:"来源"`  // 来源
	Keyword          string             `name:"关键词"` // 关键词
	OrderBy          uint               `name:"排序"`  // 排序
	UserCategorize   UserCategorize     // 用户分类
	UserCategorizeId uint               //
	ReadPoints       uint               `name:"得积分"` // 阅读可获得积分
	ExpendPoints     uint               `name:"用积分"` // 阅读需要消耗积分
	ReadNum          uint               `name:"阅读数"` // 阅读数
}
